javax.persistence.criteria

## Interface CriteriaQuery<T>

- Type Parameters:
    `T` - the type of the defined result
  All Superinterfaces:
    AbstractQuery<T>, CommonAbstractCriteria

      public interface CriteriaQuery<T>
      extends AbstractQuery<T>

  The `CriteriaQuery` interface defines functionality that is specific to top-level queries.
  Since:
    Java Persistence 2.0

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `CriteriaQuery<T>` | `distinct(boolean distinct)` Specify whether duplicate query results will be eliminated.
    `List<Order>` | `getOrderList()` Return the ordering expressions in order of precedence.
    `Set<ParameterExpression<?>>` | `getParameters()` Return the parameters of the query.
    `CriteriaQuery<T>` | `groupBy(Expression<?>... grouping)` Specify the expressions that are used to form groups over the query results.
    `CriteriaQuery<T>` | `groupBy(List<Expression<?>> grouping)` Specify the expressions that are used to form groups over the query results.
    `CriteriaQuery<T>` | `having(Expression<Boolean> restriction)` Specify a restriction over the groups of the query.
    `CriteriaQuery<T>` | `having(Predicate... restrictions)` Specify restrictions over the groups of the query according the conjunction of the specified restriction predicates.
    `CriteriaQuery<T>` | `multiselect(List<Selection<?>> selectionList)` Specify the selection items that are to be returned in the query result.
    `CriteriaQuery<T>` | `multiselect(Selection<?>... selections)` Specify the selection items that are to be returned in the query result.
    `CriteriaQuery<T>` | `orderBy(List<Order> o)` Specify the ordering expressions that are used to order the query results.
    `CriteriaQuery<T>` | `orderBy(Order... o)` Specify the ordering expressions that are used to order the query results.
    `CriteriaQuery<T>` | `select(Selection<? extends T> selection)` Specify the item that is to be returned in the query result.
    `CriteriaQuery<T>` | `where(Expression<Boolean> restriction)` Modify the query to restrict the query result according to the specified boolean expression.
    `CriteriaQuery<T>` | `where(Predicate... restrictions)` Modify the query to restrict the query result according to the conjunction of the specified restriction predicates.

    - ### Methods inherited from interface javax.persistence.criteria.AbstractQuery

      `from, from, getGroupList, getGroupRestriction, getResultType, getRoots, getSelection, isDistinct`

    - ### Methods inherited from interface javax.persistence.criteria.CommonAbstractCriteria

      `getRestriction, subquery`

- - ### Method Detail

    - #### select

          CriteriaQuery<T> select(Selection<? extends T> selection)

      Specify the item that is to be returned in the query result. Replaces the previously specified selection(s), if any.

      Note: Applications using the string-based API may need to specify the type of the select item when it results from a get or join operation and the query result type is specified.

               For example:

               CriteriaQuery<String> q = cb.createQuery(String.class);
               Root<Order> order = q.from(Order.class);
               q.select(order.get("shippingAddress").<String>get("state"));

               CriteriaQuery<Product> q2 = cb.createQuery(Product.class);
               q2.select(q2.from(Order.class)
                           .join("items")
                           .<Item,Product>join("product"));

      Parameters:
        `selection` - selection specifying the item that is to be returned in the query result
      Returns:
        the modified query
      Throws:
        `IllegalArgumentException` - if the selection is a compound selection and more than one selection item has the same assigned alias

    - #### multiselect

          CriteriaQuery<T> multiselect(Selection<?>... selections)

      Specify the selection items that are to be returned in the query result. Replaces the previously specified selection(s), if any. The type of the result of the query execution depends on the specification of the type of the criteria query object created as well as the arguments to the multiselect method.

      An argument to the multiselect method must not be a tuple- or array-valued compound selection item.

      The semantics of this method are as follows:

      - If the type of the criteria query is `CriteriaQuery<Tuple>` (i.e., a criteria query object created by either the `createTupleQuery` method or by passing a `Tuple` class argument to the `createQuery` method), a `Tuple` object corresponding to the arguments of the `multiselect` method, in the specified order, will be instantiated and returned for each row that results from the query execution.
      - If the type of the criteria query is `CriteriaQuery<X>` for some user-defined class X (i.e., a criteria query object created by passing a X class argument to the `createQuery` method), the arguments to the `multiselect` method will be passed to the X constructor and an instance of type X will be returned for each row.
      - If the type of the criteria query is `CriteriaQuery<X[]>` for some class X, an instance of type X[] will be returned for each row. The elements of the array will correspond to the arguments of the `multiselect` method, in the specified order.
      - If the type of the criteria query is `CriteriaQuery<Object>` or if the criteria query was created without specifying a type, and only a single argument is passed to the `multiselect` method, an instance of type `Object` will be returned for each row.
      - If the type of the criteria query is `CriteriaQuery<Object>` or if the criteria query was created without specifying a type, and more than one argument is passed to the `multiselect` method, an instance of type `Object[]` will be instantiated and returned for each row. The elements of the array will correspond to the arguments to the `multiselect` method, in the specified order.
      Parameters:
        `selections` - selection items corresponding to the results to be returned by the query
      Returns:
        the modified query
      Throws:
        `IllegalArgumentException` - if a selection item is not valid or if more than one selection item has the same assigned alias

    - #### multiselect

          CriteriaQuery<T> multiselect(List<Selection<?>> selectionList)

      Specify the selection items that are to be returned in the query result. Replaces the previously specified selection(s), if any.

      The type of the result of the query execution depends on the specification of the type of the criteria query object created as well as the argument to the `multiselect` method. An element of the list passed to the `multiselect` method must not be a tuple- or array-valued compound selection item.

      The semantics of this method are as follows:

      - If the type of the criteria query is `CriteriaQuery<Tuple>` (i.e., a criteria query object created by either the `createTupleQuery` method or by passing a `Tuple` class argument to the `createQuery` method), a `Tuple` object corresponding to the elements of the list passed to the `multiselect` method, in the specified order, will be instantiated and returned for each row that results from the query execution.
      - If the type of the criteria query is `CriteriaQuery<X>` for some user-defined class X (i.e., a criteria query object created by passing a X class argument to the `createQuery` method), the elements of the list passed to the `multiselect` method will be passed to the X constructor and an instance of type X will be returned for each row.
      - If the type of the criteria query is `CriteriaQuery<X[]>` for some class X, an instance of type X[] will be returned for each row. The elements of the array will correspond to the elements of the list passed to the `multiselect` method, in the specified order.
      - If the type of the criteria query is `CriteriaQuery<Object>` or if the criteria query was created without specifying a type, and the list passed to the `multiselect` method contains only a single element, an instance of type `Object` will be returned for each row.
      - If the type of the criteria query is `CriteriaQuery<Object>` or if the criteria query was created without specifying a type, and the list passed to the `multiselect` method contains more than one element, an instance of type `Object[]` will be instantiated and returned for each row. The elements of the array will correspond to the elements of the list passed to the `multiselect` method, in the specified order.
      Parameters:
        `selectionList` - list of selection items corresponding to the results to be returned by the query
      Returns:
        the modified query
      Throws:
        `IllegalArgumentException` - if a selection item is not valid or if more than one selection item has the same assigned alias

    - #### where

          CriteriaQuery<T> where(Expression<Boolean> restriction)

      Modify the query to restrict the query result according to the specified boolean expression. Replaces the previously added restriction(s), if any. This method only overrides the return type of the corresponding `AbstractQuery` method.
      Specified by:
        `where` in interface `AbstractQuery<T>`
      Parameters:
        `restriction` - a simple or compound boolean expression
      Returns:
        the modified query

    - #### where

          CriteriaQuery<T> where(Predicate... restrictions)

      Modify the query to restrict the query result according to the conjunction of the specified restriction predicates. Replaces the previously added restriction(s), if any. If no restrictions are specified, any previously added restrictions are simply removed. This method only overrides the return type of the corresponding `AbstractQuery` method.
      Specified by:
        `where` in interface `AbstractQuery<T>`
      Parameters:
        `restrictions` - zero or more restriction predicates
      Returns:
        the modified query

    - #### groupBy

          CriteriaQuery<T> groupBy(Expression<?>... grouping)

      Specify the expressions that are used to form groups over the query results. Replaces the previous specified grouping expressions, if any. If no grouping expressions are specified, any previously added grouping expressions are simply removed. This method only overrides the return type of the corresponding `AbstractQuery` method.
      Specified by:
        `groupBy` in interface `AbstractQuery<T>`
      Parameters:
        `grouping` - zero or more grouping expressions
      Returns:
        the modified query

    - #### groupBy

          CriteriaQuery<T> groupBy(List<Expression<?>> grouping)

      Specify the expressions that are used to form groups over the query results. Replaces the previous specified grouping expressions, if any. If no grouping expressions are specified, any previously added grouping expressions are simply removed. This method only overrides the return type of the corresponding `AbstractQuery` method.
      Specified by:
        `groupBy` in interface `AbstractQuery<T>`
      Parameters:
        `grouping` - list of zero or more grouping expressions
      Returns:
        the modified query

    - #### having

          CriteriaQuery<T> having(Expression<Boolean> restriction)

      Specify a restriction over the groups of the query. Replaces the previous having restriction(s), if any. This method only overrides the return type of the corresponding `AbstractQuery` method.
      Specified by:
        `having` in interface `AbstractQuery<T>`
      Parameters:
        `restriction` - a simple or compound boolean expression
      Returns:
        the modified query

    - #### having

          CriteriaQuery<T> having(Predicate... restrictions)

      Specify restrictions over the groups of the query according the conjunction of the specified restriction predicates. Replaces the previously added having restriction(s), if any. If no restrictions are specified, any previously added restrictions are simply removed. This method only overrides the return type of the corresponding `AbstractQuery` method.
      Specified by:
        `having` in interface `AbstractQuery<T>`
      Parameters:
        `restrictions` - zero or more restriction predicates
      Returns:
        the modified query

    - #### orderBy

          CriteriaQuery<T> orderBy(Order... o)

      Specify the ordering expressions that are used to order the query results. Replaces the previous ordering expressions, if any. If no ordering expressions are specified, the previous ordering, if any, is simply removed, and results will be returned in no particular order. The left-to-right sequence of the ordering expressions determines the precedence, whereby the leftmost has highest precedence.
      Parameters:
        `o` - zero or more ordering expressions
      Returns:
        the modified query

    - #### orderBy

          CriteriaQuery<T> orderBy(List<Order> o)

      Specify the ordering expressions that are used to order the query results. Replaces the previous ordering expressions, if any. If no ordering expressions are specified, the previous ordering, if any, is simply removed, and results will be returned in no particular order. The order of the ordering expressions in the list determines the precedence, whereby the first element in the list has highest precedence.
      Parameters:
        `o` - list of zero or more ordering expressions
      Returns:
        the modified query

    - #### distinct

          CriteriaQuery<T> distinct(boolean distinct)

      Specify whether duplicate query results will be eliminated. A true value will cause duplicates to be eliminated. A false value will cause duplicates to be retained. If distinct has not been specified, duplicate results must be retained. This method only overrides the return type of the corresponding `AbstractQuery` method.
      Specified by:
        `distinct` in interface `AbstractQuery<T>`
      Parameters:
        `distinct` - boolean value specifying whether duplicate results must be eliminated from the query result or whether they must be retained
      Returns:
        the modified query.

    - #### getOrderList

          List<Order> getOrderList()

      Return the ordering expressions in order of precedence. Returns empty list if no ordering expressions have been specified. Modifications to the list do not affect the query.
      Returns:
        the list of ordering expressions

    - #### getParameters

          Set<ParameterExpression<?>> getParameters()

      Return the parameters of the query. Returns empty set if there are no parameters. Modifications to the set do not affect the query.
      Returns:
        the query parameters

Copyright © 1996-2013, Oracle and/or its affiliates. All Rights Reserved. Use is subject to license terms.